/* Хʥ꤫ Shift_JIS ,EUCѴ */
/* 2000(c) MURAKAMI Tomokazu */

#include <stdio.h>

#define _iskanji(c) ((c)>=0x81&&(c)<=0x9f||(c)>=0xe0&&(c)<=0xfc)
#define iskanji(c) (_ktype[(c) & 0xff])
#define ON 1
#define OFF 0
#define TRUE 1
#define FALSE 0
#define KO 0xba

int _ktype[0x100];

void iniktype(void)
{
  register int i;

  for(i=0; i<0x100 ; i++)
    if(_iskanji(i) )
      _ktype[i] = TRUE;
    else
      _ktype[i] = FALSE;
}

inline int char2K(int c0, int c1)
{
  return (( c0&0xff) <<8 | (c1&0xff)  );
}

int sjis2euc(int c)
{
  /* SJIS 2 EUC ʰ */
  int hi, lo;

  hi = (c>>8) & 0xff;
  lo = c & 0xff;
  hi -= (hi <= 0x9f) ? 0x71 : 0xb1;
  hi = hi *2 +1;
  if(lo > 0x7f)
    lo--;
  if(lo >= 0x9e){
    lo -= 0x7d;
    hi++;
  }else
    lo -= 0x1f;

  return ( (hi <<8) | lo | 0x8080 );
}


inline int putK(int c)
{
  putchar( (c>>8) & 0xff) ;
  putchar(  c & 0xff );
}

int main(int ac, char *av[])
{
  FILE *fp;
  int c,c0,c1;

  iniktype();
  
  if (( fp = fopen(av[1],"r")) == NULL){
    fprintf(stderr,"File cannot open.\n");
    return;
  }

  while(( c = getc(fp) ) != EOF){
    
    if( iskanji(c)){
      c1 = getc(fp);
      if( (c1 >=0x40 && c1 <=0x7e)|| ( c1 >= 0x80 && c1 <= 0xfc)){
	putK( sjis2euc( char2K( c ,c1 )));
	//	putK(  char2K( c ,c1 ) );
      }else{
	ungetc(c1,fp);
      }
    
    }

  }
  putchar('\n');
  fclose(fp);

  return 0;
}
